#include "StdFps.h"

float FPS::GetFpsFloat() //Returns the current average FPS as a float
{
	DWORD CurrentTicks=GetTickCount();
	float AverageFPS=(1000.0f*FrameOn/(float)(CurrentTicks-OldTicks));

	if((CurrentTicks-OldTicks)>2000) //After 2 seconds is up, move the number frames from the last second *only* into a buffer to keep the framerate accurate
	{
		FrameOn-=LastTotalFrames;
		LastTotalFrames=FrameOn;
		OldTicks=StoreTicks;
		StoreTicks=CurrentTicks;
	}
	return AverageFPS;
}

char* FPS::GetFpsString(int NumberOfDecimals) //Returns the current average FPS as a string with the provided accuracy
{
	if(LastFpsStringPointer!=NULL) //Delete the last fps string
		delete[] LastFpsStringPointer;

	char *PrintFPS = new char[9+NumberOfDecimals];
	FillMemory(PrintFPS,9+NumberOfDecimals,0);
	if(NumberOfDecimals==0)
	{
		DWORD AverageFPS=GetFpsDWORD();
		ltoa(AverageFPS, PrintFPS, 10);
	}
	else
	{
		float AverageFPS=GetFpsFloat();
		gcvt(AverageFPS, NumberOfDecimals, PrintFPS);
	}
	strcat(PrintFPS, " fps");
	LastFpsStringPointer=PrintFPS;
	return PrintFPS;
}